<?php

# --------------------------------------------
# chet Chemnitzer Thesaurus
# (C) 2002 Frank Hofmann, Chemnitz, Germany
# email fho@informatik.tu-chemnitz.de
# --------------------------------------------

# changed 2002-08-20

# create analyse page

# include ressource files
include ("source/header.php");
include ("source/footer.php");
include ("source/navigation.php");
include ("source/ct_definitionen.php");
include ("source/wn_interface.php");

# document header, headline
$Headline = Navigation_Table ("analyse", "headline");
Create_header_Ct ($Headline);

Ct_Navigation_Begin ("analyse");

# check for valid parameters
# look how we are called

# echo "<!-- $Input_Text -->\n";

# split incoming data into single words
$Cache = Split_Text($Input_Text);
$Number_Of_Words = WN_Count_Words($Cache, 1);
$Number_Of_Items = sizeof($Cache);

# 
# echo "<hr>[Call: $Call, PP: $Parser_Position]<hr><br>\n";
# echo "<-- $Number_Of_Words, $Number_Of_Items -->\n";

if ($Call==$Index_Page) {
	$Parser_Position = 0;
} # end if

if ($Call==$Analyse_Back) {
	# update selected word

	$Cache = WN_Update ($Cache, 1, $Parser_Position, $Search_Result[0]);
	$Number_Of_Words = WN_Count_Words($Cache, 1);
	$Number_Of_Items = sizeof($Cache);
	$Input_Text = Unsplit_Words ($Cache, 0, $Number_Of_Items);

	$Parser_Position = $PP_Back;
	if($Parser_Position<0) {
		$Parser_Position = 0;
	} # end if
} # end if

if ($Call==$Analyse_Forward) {

	$Cache = WN_Update ($Cache, 1, $Parser_Position, $Search_Result[0]);
	$Number_Of_Words = WN_Count_Words($Cache, 1);
	$Number_Of_Items = sizeof($Cache);
	$Input_Text = Unsplit_Words ($Cache, 0, $Number_Of_Items);

	$Parser_Position = $PP_Next;
	if($Parser_Position > $Number_Of_Words - 1) {
		$Parser_Position = $Number_Of_Words - 1;
	} # end if
} # end if

if ($Call==$Analyse_Previous_Sentence) {
	$Cache = WN_Update ($Cache, 1, $Parser_Position, $Search_Result[0]);
	$Number_Of_Words = WN_Count_Words($Cache, 1);
	$Number_Of_Items = sizeof($Cache);
	$Input_Text = Unsplit_Words ($Cache, 0, $Number_Of_Items);

	$Parser_Position = $PP_Previous_Sentence;
	if($Parser_Position > $Number_Of_Words - 1) {
		$Parser_Position = $Number_Of_Words - 1;
	} # end if
} # end if

if ($Call==$Analyse_Next_Sentence) {
	$Cache = WN_Update ($Cache, 1, $Parser_Position, $Search_Result[0]);
	$Number_Of_Words = WN_Count_Words($Cache, 1);
	$Number_Of_Items = sizeof($Cache);
	$Input_Text = Unsplit_Words ($Cache, 0, $Number_Of_Items);

	$Parser_Position = $PP_Next_Sentence;
	if($Parser_Position > $Number_Of_Words - 1) {
		$Parser_Position = $Number_Of_Words - 1;
	} # end if
} # end if

# echo "<hr>[Call: $Call, PP: $Parser_Position]<hr><br>\n";
# echo "<-- $Number_Of_Words, $Number_Of_Items -->\n";

# build select form

echo "<p>\n";
echo "Analysed text:\n<br><br>\n";

$Look_At = 0;
$Counter_Selectform = 0;

if ($Input_Proceed==0) {
	# word by word
	# keep parser position

	# user input is sent to this form
	echo "<form action=\"analyse.php\" method=\"post\">\n";
} else {
	# the whole passage
	# reset parser position
	$Parser_Position = 0;

	# user input is sent to this form
	echo "<form action=\"final_text.php\" method=\"post\">\n";
} # end if

# display text
reset ($Cache);
while (list($Frame_ID, $Current_Frame) = each($Cache)) {
	$Current_Type = $Current_Frame[0];
	$Current_Word = $Current_Frame[1];

	# echo "PP: $Parser_Position, FrameID: $Frame_ID, LookAt: $Look_At<br>\n";

	# output the word without alternatives
	$Show_Alternatives=0;

	if($Input_Proceed==0) {
		# word-by-word
		$Value = Pointer_To_Key ($Cache, 1, $Parser_Position);
		# echo "[Value: $Value]<br>\n";
		if($Value == $Frame_ID) {
			$Show_Alternatives = 1;
		} # end if
	} else {
		# whole passage
		if($Current_Type==1) {
			$Show_Alternatives=1;
		} # end if
	} # end if

	# analyse currently parsed word
	if ($Show_Alternatives==1) {

		# check for alternatives
		# echo "<i>WN_Get_Alternatives: $Current_Word $WN_Path</i>\n";
		$Alternatives = WN_Get_Alternatives($WN_Path, $Current_Word);
	
		# add a basic entry and put it on top the array
		# so we always have at least one entry (array item)
		$Basic_Entry = array($Current_Word, $Current_Word);
		array_unshift($Alternatives, $Basic_Entry);
	
		# display result
		echo "\n<select name=\"Search_Result[$Counter_Selectform]\" size=\"1\">\n";
	
		reset ($Alternatives);
		while (list($Key, $Alternative_Item) = each($Alternatives)) {
			$Show_Word = Substitute_Apostrophes ($Alternative_Item[0]);
			$Show_Meaning = Substitute_Apostrophes ($Alternative_Item[1]);

			echo "<option value=\"$Show_Word\">$Show_Meaning\n";
		} # end while
	
		echo "</select>\n";

		# increase counter
		$Counter_Selectform++;

	} else {
		# simply output the current word
		# echo "<!-- $Current_Word -->\n";
		if ($Current_Word == "<em>") {
			echo "<em id=\"extra\">";
		} else {
			if ($Current_Word == "</em>") {
				echo "</em>";
			} else {
				$Output_Phrase = Substitute_Apostrophes ($Current_Word);
				echo "$Output_Phrase";
			} # end if
		} # end if
	} # end if
	
	if($Input_Proceed > 0) {
		echo "<br>\n";
	} # end if

} # end while
	
# close form and display a different list of buttons

# transfer Input_Proceed & SelectForm-Counter

	$Transfer_Text = stripslashes($Input_Text);
	echo "<input type=\"hidden\" name=\"Input_Proceed\" value=\"$Input_Proceed\">\n";
	echo "<input type=\"hidden\" name=\"Counter_Selectform\" value=\"$Counter_Selectform\">\n";
	echo "<input type=\"hidden\" name=\"Input_Text\" value=\"$Transfer_Text\">\n";

if ($Input_Proceed==0) {
	# word by word

	echo "</p>\n";
	echo "<hr width=\"100%\">\n";
	
	echo "<table cols=\"5\">\n";
	echo "<tr><td>\n";
	echo "<input type=\"reset\" value=\"Reset\">\n";
	echo "</td><td>\n";
	
	$Next_PP = Find_Previous_Sentence ($Cache, $Parser_Position);
	echo "<input type=\"submit\" value=\"&lt;&lt; Back\" name=\"Call\">\n";
	echo "<input type=\"hidden\" name=\"PP_Previous_Sentence\" value=\"$Next_PP\">\n";
	
	echo "</td><td>\n";
	
	$Next_PP = $Parser_Position - 1;
	echo "<input type=\"hidden\" name=\"Parser_Position\" value=\"$Parser_Position\">\n";
	echo "<input type=\"submit\" value=\"&lt; Back\" name=\"Call\">\n";
	echo "<input type=\"hidden\" name=\"PP_Back\" value=\"$Next_PP\">\n";
	
	echo "</td><td>\n";
	
	$Next_PP = $Parser_Position + 1;
	echo "<input type=\"submit\" value=\"Next &gt;\" name=\"Call\">\n";
	echo "<input type=\"hidden\" name=\"PP_Next\" value=\"$Next_PP\">\n";

	echo "</td><td>\n";
	
	$Next_PP = Find_Next_Sentence ($Cache, $Parser_Position);
	echo "<input type=\"submit\" value=\"Next &gt;&gt;\" name=\"Call\">\n";
	echo "<input type=\"hidden\" name=\"PP_Next_Sentence\" value=\"$Next_PP\">\n";
	
	echo "</td><td>\n";
	echo "</form>\n";
		
	echo "<form action=\"index.php\" method=\"post\">\n";
	echo "<input type=\"submit\" value=\"Cancel\">\n";
	echo "</form>\n";
	
	echo "</td><td>\n";
	
	echo "<form action=\"final_text.php\" method=\"post\">\n";
	echo "<input type=\"submit\" value=\"Finish\">\n";
	echo "<input type=\"hidden\" name=\"Input_Text\" value=\"$Input_Text\">\n";
	echo "<input type=\"hidden\" name=\"Parser_Position\" value=\"$Parser_Position\">\n";
	echo "</form>\n";

	echo "</td></tr>\n";
	echo "</table>\n";
} else {
	# whole passage

	echo "<hr width=\"100%\">\n";
	
	echo "<table cols=\"3\">\n";
	echo "<tr><td>\n";
	echo "<input type=\"reset\" value=\"Reset\">\n";
	echo "</td><td>\n";

	echo "<input type=\"submit\" value=\"Finish\">\n";
	echo "</form>\n";

	echo "</td><td>\n";

	echo "<form action=\"index.php\" method=\"post\">\n";
	echo "<input type=\"submit\" value=\"Cancel\">\n";
	echo "</form>\n";

	echo "</td></tr>\n";	
	echo "</table>\n";
	
} # end if

Ct_Navigation_End ();

# document footer
Create_Footer_Ct ();
?>
