<?php	

# --------------------------------------------
# chet Chemnitzer Thesaurus
# (C) 2002 Frank Hofmann, Chemnitz, Germany
# email fho@informatik.tu-chemnitz.de
# --------------------------------------------

# routines for displaying a table

# changed 2002-08-11

function tabelle($Zeilen, $Spalten, $Text, $URL, $Target, $Zeile_Selected, $Spalte_Selected)
{
	# Creates a table (1 row, n columns) or (n rows, 1 column)
	# Text, URL and target mean a link and a possible target
	# Zeile_Selected, Spalte_Selected specify the selected row or column
	# if Zeile_selected = Spalte_Selected <1 then background color is white

	# Colors
	$Color_Selected = "#FFFFAA";
	$Color_Standard = "#DDDDFF";

	# HTML tags for creating a table
	echo "<table CELLSPACING=2 CELLPADDING=2 COLS=$Spalten BGCOLOR=\"#FFFFFF\">\n";

	# number of rows
	for ($index_Z=1;$index_Z<=$Zeilen;$index_Z++) {
	
		# table row
		echo "<tr>\n";

		for ($index_S=1;$index_S<=$Spalten;$index_S++) {
			$Color_Output = $Color_Standard;

			if (($Zeile_Selected == $index_Z) && ($Spalte_Selected == $index_S)) {
				$Color_Output = $Color_Selected;
			}

			# Zeilen- oder spaltenweise anordnen
			# Standard: zeilenweise
			$index_item = $index_Z;
			if ($Zeilen == 1) {
				# spaltenweise anordnen
				$index_item = $index_S;
			}


			# if empty string, don't create a link
			$URL_length = strlen($URL[$index_item]);

			# if empty string, create white space
			$Text_length = strlen($Text[$index_item]);

			# Tabellenzelle in entsprechender Farbe
			echo "<td BGCOLOR=\"$Color_Output\">\n";
				
			# Font
//			echo "<font face='Arial,Helvetica' size=-1>\n";

			# include URL
			if ($URL_length > 0) {
				echo "<a href=\"$URL[$index_item]\" target=\"$Target[$index_item]\">";
			}

			# output Text
			if ($Text_length > 0) {
				echo "$Text[$index_item]";
			} else {
				echo "&nbsp;";
			}

			# close URL
			if ($URL_length > 0) { echo "</a>"; }

			# end of font
//			echo "</font>\n";

			# Tabellenzelle - Endetag
			echo "</td>\n";
		}

		# Tabellenzeile - Endetag
		echo "</tr>\n\n";
	}

	# Tabelle abschliessen
	echo "</table>\n\n";

	return;
}

function tabelle_text_mini ($Text) {

	# creates a table with one column and one row, only
	# and without links, just text

	# no URL and target
	$URL = "";
	$Target = "";

	# create table
	tabelle(1, 1, $Text, $URL, $Target, 0, 0);

	return;

}

function Table_Cell ($Flag) {

	# creates a cell

	$Color = "#FFFFFF";
	if (!$Flag == 0) { $Color = "#FF0000"; }

	echo "<td BGCOLOR=\"$Color\" align=\"middle\">\n";
	return;
}
		
?>
