<?php

# --------------------------------------------
# chet Chemnitzer Thesaurus
# (C) 2002 Frank Hofmann, Chemnitz, Germany
# email fho@informatik.tu-chemnitz.de
# --------------------------------------------

# changed 2002-08-11

# WordNet interface functions
# works together with WordNet 1.6

function Split_Text ($Input_Text) {
	# split incoming data into single words

	$All_Chars = strlen ($Input_Text);
	$List_Of_Words = array();
	$Delimiters = "\s,.;:";
	$Reg_Expr = "/[" . $Delimiters . "]+/";

	$Still_To_Process = $All_Chars;
	$Look_At = 0;
	$Cache = "";
	$Char_Mode = 1;	# check for words, 2: delimiters, 3: tags
	$Lookup_Mode = 0; # which lookup mode we are in: 1 between tags

	while ($Still_To_Process) {
		$Current_Char = substr($Input_Text, $Look_At, 1);

		$Delimiters = "\s,.;:";
		$Reg_Expr = "/[" . $Delimiters . "]+/";

		if (preg_match ($Reg_Expr, $Current_Char)) {
			if ($Char_Mode==1) {
				# currently, we work with words, but found a delimiter
				if (strlen($Cache)>0) {
					# There are already chars in the cache - add them to the list

					# Before doing that, we will check the cache for special
					# chars needed to tag this word

					# test for patterns like <b>word</b>
					# beginning tag
					$Delimiters = "\w+";
					$Reg_Expr = "/<" . $Delimiters . ">(\w+)<\/" . $Delimiters . ">/";

					echo "<!-- [ 0 $Cache, $Keep_Cache ] -->\n";

					if(preg_match ($Reg_Expr, $Cache)) {
						# yesss .... here is one
						$Reg_Expr = "/<" . $Delimiters . ">/";
						preg_match ($Reg_Expr, $Cache, $Out);
						$R_Out = $Out[0];
						# echo "[ 1 $R_Out ]\n";
						$List_Of_Words[] = array (3, $R_Out);

						# word covered by tags
						$Reg_Expr = "/<" . $Delimiters . ">(\w+)<\/" . $Delimiters . ">/";
						preg_match_all ($Reg_Expr, $Cache, $Out);
						$tmp = $Out[1][0];
						# echo "[ 2 $tmp ]\n";
						$List_Of_Words[] = array (1, $tmp);

						# end tag
						$Reg_Expr = "/<\/" . $Delimiters . ">/";
						preg_match ($Reg_Expr, $Cache, $Out);
						$R_Out = $Out[0];
						# echo "[ 3 $R_Out ]\n";
						$List_Of_Words[] = array (3, $R_Out);
					} else {
						# maybe we have a term like <b>word something else</b>
						# check for <b>word
						echo "<!-- check starts -->\n";
						$Reg_Expr = "/<" . $Delimiters . ">(\w+)/";
						if(preg_match ($Reg_Expr, $Cache)) {
							$Lookup_Mode = 1; # tag found
							$Keep_Cache = $Cache;

							echo "<!-- Lookup mode = 1 -->\n";
						} else {
							# check for word</b>
							$Reg_Expr = "/(\w+)<\/" . $Delimiters . ">/";
							if(preg_match ($Reg_Expr, $Cache)) {
								$Keep_Cache = $Keep_Cache . " " . $Cache;
								$Lookup_Mode = 0;

								echo "<!-- Lookup Mode = 0 -->\n";
								$Reg_Expr = "/<" . $Delimiters . ">/";
								preg_match ($Reg_Expr, $Keep_Cache, $Out);
								$R_In = $Out[0];
								 echo "<!-- [ 1 $R_In ] -->\n";
								# $List_Of_Words[] = array (3, $R_In);

								# remove beginning tag
								$R_In_Length = strlen ($R_In);
								$Keep_Cache = substr ($Keep_Cache, $R_In_Length); 
								 echo "<!-- [ 2 $Keep_Cache ] -->\n";

								# remove ending tag
								$Reg_Expr = "/<\/" . $Delimiters . ">/";
								preg_match ($Reg_Expr, $Keep_Cache, $Out);
								$R_Out = $Out[0];
								$R_Out_Length = strlen ($R_Out);
								$Keep_Cache_Length = strlen($Keep_Cache) - $R_Out_Length;
								echo "<!-- [ 3 $R_Out_Length, $Keep_Cache_Length ] -->\n";
								$Keep_Cache = substr ($Keep_Cache, 0, $Keep_Cache_Length); 
								echo "<!-- [ 4 $Keep_Cache ] -->\n";

								# word between tags
								$Out = explode (" ", $Keep_Cache);
								while(list($key,$item) = each($Out)) {
									echo "<!-- [ 5 . $key, $item -->\n";
									$List_Of_Words[] = array (3, $R_In);
									$List_Of_Words[] = array (1, $item);
									$List_Of_Words[] = array (3, $R_Out);
									$List_Of_Words[] = array (2, " ");
								} # end while

								# end tag
							} else {
								if($Lookup_Mode == 1) {
									$Keep_Cache = $Keep_Cache . $Cache;
								} else {
									# no ... not found :-|
									# add full cache
									$List_Of_Words[] = array (1, $Cache);
								} # end if
							} # end if
						} # end if
					} # end if

				} # end if

				# empty cache
				$Cache = $Current_Char;

				# work with delimiters, now
				$Char_Mode = 2;

			} else {
				# we found another delimiter which we add
				$Cache = $Cache . $Current_Char;
			} # end if
		} else {
			if ($Char_Mode==2) {
				# currently, we work with delimiters, but found a char
				if (sizeof($Cache)>0) {
					# There are already chars in the cache - add them to the list

					$List_Of_Words[] = array ($Char_Mode, $Cache);
				} # end if

				# empty cache
				$Cache = $Current_Char;

				# work with words, now
				$Char_Mode = 1;
			} else {
				# we found another char which we add
				$Cache = $Cache . $Current_Char;
			} # end if
		} # end if

		$Look_At++;
		$Still_To_Process--;
	} # end while

	# check the cache - is there still something in it?
	if (sizeof($Cache)>0) {
		# There are chars in the cache - add them to the list
		$List_Of_Words[] = array ($Char_Mode, $Cache);
	} # end if

	return $List_Of_Words;
}

function WN_Count_Words ($Big_List, $Type) {
	# returns the number of words given in the list which belong to the specified type

	$Count = 0;
	while(list($key,$item) = each($Big_List)) {
		if ($item[0] == $Type) {
			$Count++;
		} # end if
	} # end while

	return $Count;

}

function WN_Count_Words_Key ($Big_List, $Type, $Key) {
	# returns the number of words given in the list which belong to the specified type
	# count until the key'th item, only

	$Count = 0;
	while(list($no,$item) = each($Big_List)) {
		if ($no<$Key) {
			if ($item[0] == $Type) {
				$Count++;
			} # end if
		} else {
			break;
		} # end if
	} # end while

	return $Count;

}

function WN_Get_Next_Item ($Big_List, $Type, $Pointer_Position) {
	# starts from a pointer position and returns 1 if the next item is available,
	# otherwise 0

	$Frames = sizeof($Big_List);
	return;
}

function Pointer_To_Key ($Big_List, $Type, $Pointer_Position) {
	# returns which entry in Big_List you are pointing to

	$Count = -1;
	while(list($no,$item) = each($Big_List)) {
		if ($item[0] == $Type) {
			$Count++;
			# echo "[(PTK) PP:$Pointer_Position, Count:$Count, No:$no]<br>\n";
			if($Count == $Pointer_Position) {
				return ($no);
			} # end if
		} # end if
	} # end while

	return -1;
}

function WN_Get_Alternatives ($Path, $Current_Word) {
	# returns all the alternative words for the query
	$Alternatives = array();

	# make a WordNet request 
	$New_Meanings = WN_Request ($Path, $Current_Word);

	# let us have cat the result
	$Output = "";
	while(list($key,$item) = each($New_Meanings)) {
		$Output = $Output . "$item\n";
	} # end if

	# use a regexp to get all the interesting lines from the output
	$Reg_Exp = "/Sense\s.\s.*\s.*/";

	# echo "($Reg_Exp)";
	preg_match_all ($Reg_Exp, $Output, $Matches);

	while(list($key2,$item2) = each($Matches[0])) {
		# echo "<br>$key2:$item2\n";

		# get all chars between two \n's
		$Reg_Exp = "/\n.*\n/";
		preg_match ($Reg_Exp, $item2, $Matches2);
		# echo "$Matches2[0]<br>";

		# remove the 0est and the last char ("\n")
		$Match_Len = strlen ($Matches2[0]);
		$New_Match = substr ($Matches2[0], 1, $Match_Len - 2);

		# split the phrase by any number of commas or space characters,
		# which include " ", \r, \t, \n and \f
		$Reg_Exp = "/,\s/";
		$Keywords = preg_split ($Reg_Exp, $New_Match);

		# get the sense number
		$Reg_Exp = "/Sense\s./";
		preg_match ($Reg_Exp, $item2, $Sense_Matches);
		$Sense_ID = $Sense_Matches[0];

		# get the meaning class
		$Reg_Exp = "/=>.*/";
		preg_match ($Reg_Exp, $item2, $Class_Matches);
		$Meaning_Class = $Class_Matches[0];
     
		# substitute "=>" by "meaning:" 
		$Meaning_Class = preg_replace ("'=>'", "meaning:", $Meaning_Class);

		# add each keyword to the list of alternatives		
		while(list($key3,$item3) = each($Keywords)) {
			$Alternatives[] = array("$item3", $Sense_ID .": " . $item3 . " (" . $Meaning_Class . ")");
		} # end while
	} # end while

	return $Alternatives;
}

function WN_Get_Alternatives_List ($Path, $Current_Word) {
	# returns a list of words, only
	# sorted and uniqued

	$List_Of_Items = WN_Get_Alternatives ($Path, $Current_Word);
	$New_List = array();
	while(list($key,$item) = each ($List_Of_Items)) {
		$New_List[] = $item[0];
	} # end while

	$New_List = array_unique($New_List);
	sort($New_List);

	return $New_List;
}

function WN_Request ($Path, $Nomen) {
	# sends a request to WordNet
	exec ("$Path $Nomen -synsn", $WN_Output, $Return_Var);

	return $WN_Output;
}

function WN_Update ($Big_List, $Type, $Index, $New_Word) {
	# substitute/update the specified list entry

	$Work_With = $Big_List;

	$Count = 0;
	while(list($key,$item) = each($Big_List)) {
		if ($item[0] == $Type) {
			if ($Count<$Index) {
				$Count++;
			} else {
				# item reached - update, if necessary

				# compare both the new and old item
				if (strcmp($item[1], $New_Word) == 0) {
					# equal - do nothing
					break;
				} else {
					# different - update now
					$item[1] = $New_Word;
					$Big_List[$key] = $item;

					# did we update this word before?
					# check for update tags 

					if ($key>0) {
						# check entry $key - 1
						if($Big_List[$key - 1][0]==3) {
							# already changed - do nothing
						} else {
							# remember changes by adding a <updated> tag
							$item[1] = "<em>$New_Word</em>";
							$Big_List[$key] = $item;
						} # end if
					} else {
						# it is the zeroest entry - update
						# remember changes by adding a <updated> tag
						$item[1] = "<em>$New_Word</em>";
						$Big_List[$key] = $item;
					} # end if
				} # end if

				break;
			} # end if
		} # end if
	} # end while

	# in case we added an item that we have to rearrange this list
	$New_Text = Unsplit_Words ($Big_List, 0, sizeof($Big_List));
	$Big_List = Split_Text ($New_Text);

	return $Big_List;
}

function Unsplit_Words ($Big_List, $From_Word, $To_Word) {
	# concats all the list entries

	$Full_Text = "";

	while(list($key,$item) = each($Big_List)) {
		if(($key>=$From_Word) || ($key<=$To_Word)) {
			$Full_Text = $Full_Text . $item[1];
		} # end if
	} # end while

	return $Full_Text;
}

function Is_Sentence_End ($Item) {
	# 1 if so, otherwise 0

	$Reg_Exp = "/\s*\.\s*/";
	if (preg_match ($Reg_Exp, $Item)) {
		return 1;
	} else {
		return 0;
	} # end if
}

function Find_Previous_Sentence ($Big_List, $Pointer_Position) {
	# returns the Pointer Position for the beginning of the previous sentence

	$Here_We_Go = Pointer_To_Key($Big_List, 1, $Pointer_Position);
	$Dots = 0;

	while ($Here_We_Go >= 0) {
		$Frame = $Big_List[$Here_We_Go];
		if($Frame[0] == 2) {
			$Item = $Frame[1];
			if (Is_Sentence_End ($Item) == 1) {
				# we discovered a sentence end

				$Dots++;
				if($Dots==2) {
					break;
				};
			} # end if;
		} # end if

		$Here_We_Go--;
	} # end while

	$R = WN_Count_Words_Key ($Big_List, 1, $Here_We_Go);

	return $R;
}

function Find_Next_Sentence ($Big_List, $Pointer_Position) {
	# returns the Pointer Position for the next sentence

	$Here_We_Go = Pointer_To_Key($Big_List, 1, $Pointer_Position);

	$Entries = sizeof($Big_List);
	while (list($Key, $Frame) = each($Big_List)) {
		# echo "<!-- $Key, $Pointer_Position, $Here_We_Go -->\n";
		if($Key==$Here_We_Go) {
			if($Frame[0] == 2) {
				$Item = $Frame[1];
				if (Is_Sentence_End ($Item) == 1) {
					# we discovered a sentence end
					break;
				} # end if;
			} # end if

			$Here_We_Go++;
		} # end if
	} # end while

	$R = WN_Count_Words_Key ($Big_List, 1, $Here_We_Go);
#	echo "<!--[ $Here_We_Go ]-->\n";
	return $R;
}

function Substitute_Apostrophes ($Input_String) {
	# substitute apostrophes

	# substitute "\'" by "'" 
	# $Output_String = preg_replace ("\'", "&#039;", $Input_String);
	$Output_String = stripslashes($Input_String);
	$Output_String = htmlentities($Output_String, ENT_QUOTES);

	return $Output_String;
}

?>
